﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=5.9
@EndOfDesignText@
'Static Code Module:	ABMShared
'Project:				OilTank60

Sub Process_Globals
	Public MyTheme As ABMTheme	
	Private ABM As ABMaterial 'ignore	
	Public NeedsAuthorization As Boolean = False
	Public AppVersion As String = DateTime.now ' NEW 2.01 this helps to get the latest js/css files when the app is started/restarted
	Public AppPublishedStartURL As String = ""
	Public AppName As String = "OilTank60"
	
	Public CachedPages As Map
	Public CacheScavengePeriodSeconds As Int = 15*60 ' 15 minutes 
	Public SessionMaxInactiveIntervalSeconds As Int = 30*60 ' 30 minutes '1*60*24 ' one hour ' -1 = immortal but beware! This also means your cache is NEVER emptied!
End Sub

'----------------------START MODIFICATION 4.00-------------------------------
Public Sub NavigateToPage(ws As WebSocket, PageId As String, TargetUrl As String) 'ignore	
	Dim testTargetUrl As String = TargetUrl
	If Not(testTargetUrl.EndsWith(".htm") Or testTargetUrl.EndsWith(".html") Or testTargetUrl.EndsWith("/")) Then
		TargetUrl = TargetUrl & "/"
	End If
	If PageId.Length > 0 Then ABM.RemoveMeFromCache(CachedPages, PageId)
	If ws.Open Then
		' it doesn't keep navigation history in the browser (the back button exists the application)
		'ws.Eval("window.location.replace(arguments[0])", Array As Object(TargetUrl))
		' if you need browser history just comment the lines above and uncomment the lines below
		' it keeps the navigation history in the browser
		ws.Eval("window.location = arguments[0]", Array As Object(TargetUrl))
		ws.Flush
		ws.Close ' ALSO NEW 4.00	
	End If	
End Sub
'----------------------END MODIFICATION 4.00-------------------------------

'----------------------START MODIFICATION 4.00-------------------------------
Public Sub NavigateToPageNewTab(ws As WebSocket, PageId As String, TargetUrl As String, OpenInNewTab As Boolean) 'ignore	
	Dim testTargetUrl As String = TargetUrl
	If Not(testTargetUrl.EndsWith(".htm") Or testTargetUrl.EndsWith(".html") Or testTargetUrl.EndsWith("/")) Then
		TargetUrl = TargetUrl & "/"
	End If
	If PageId.Length > 0 Then ABM.RemoveMeFromCache(CachedPages, PageId)
	If ws.Open Then
		If OpenInNewTab Then
			Dim s As String
			' check if a mobile phone only
'			s = $"var check = false;
'  			(function(a){if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4))) check = true;})(navigator.userAgent||navigator.vendor||window.opera);
'  			if (check) {
'  				window.location = arguments[0];
'  			} else {
'  				window.open(arguments[0],'_blank');  				
'  			}"$
			
			' check if a mobile phone or a tablet
			s = $"var check = false;
  			(function(a){if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino|android|ipad|playbook|silk/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4))) check = true;})(navigator.userAgent||navigator.vendor||window.opera);
   			if (check) {
  				window.location = arguments[0];
  			} else {
				window.open(arguments[0],'_blank');  				
  			}"$			
			ws.Eval(s, Array As Object(TargetUrl))							
		Else
			ws.Eval("window.location = arguments[0]", Array As Object(TargetUrl))			
		End If
		ws.Flush
		ws.Close ' ALSO NEW 4.00
	End If	
End Sub
'----------------------END MODIFICATION 4.00-------------------------------

Sub RedirectOutput (Dir As String, FileName As String) 'ignore
   #if RELEASE
   Dim out As OutputStream = File.OpenOutput(Dir, FileName, False) 'Set to True to append the logs
   Dim ps As JavaObject
   ps.InitializeNewInstance("java.io.PrintStream", Array(out, True, "utf8"))
   Dim jo As JavaObject
   jo.InitializeStatic("java.lang.System")
   jo.RunMethod("setOut", Array(ps))
   jo.RunMethod("setErr", Array(ps))
   #end if
End Sub

Sub LogOff(page As ABMPage) 'ignore
	' do whatever you have to do to log off your user
			
	page.ws.Session.SetAttribute("IsAuthorized", "")				
	NavigateToPage(page.ws, page.GetPageID, "../")	
End Sub

' build methods for ABM objects
Sub BuildTheme(themeName As String)
	MyTheme.Initialize(themeName)
	
	' the page theme
	'MyTheme.Page.BackColor = ABM.COLOR_WHITE
	MyTheme.Page.BackColor = ABM.COLOR_GREY
	MyTheme.Page.BackColorIntensity = ABM.INTENSITY_LIGHTEN5

	' Cells
	MyTheme.AddCellTheme("alignleft")
	MyTheme.Cell("alignleft").Align = ABM.CELL_ALIGN_LEFT
	MyTheme.AddCellTheme("aligncenter")
	MyTheme.Cell("aligncenter").Align = ABM.CELL_ALIGN_CENTER
	MyTheme.AddCellTheme("alignright")
	MyTheme.Cell("alignright").Align = ABM.CELL_ALIGN_RIGHT
	MyTheme.AddCellTheme("lineargauge")
	MyTheme.Cell("lineargauge").BackColor = ABM.COLOR_GREY
	MyTheme.Cell("lineargauge").BackColorIntensity = ABM.INTENSITY_LIGHTEN5
	MyTheme.AddCellTheme("controlswitch")
	MyTheme.Cell("controlswitch").Align = ABM.CELL_ALIGN_CENTER
	MyTheme.Cell("controlswitch").VerticalAlign = True
	MyTheme.Cell("controlswitch").BorderColor = ABM.COLOR_GREY
	MyTheme.Cell("controlswitch").BorderStyle = ABM.BORDER_SOLID	' ABM.BORDER_RIDGE
	MyTheme.Cell("controlswitch").BorderColorIntensity = ABM.INTENSITY_LIGHTEN2
	MyTheme.Cell("controlswitch").BorderWidth = 2
	MyTheme.Cell("controlswitch").BackColor = ABM.COLOR_GREY
	MyTheme.Cell("controlswitch").BackColorIntensity = ABM.INTENSITY_LIGHTEN3

	MyTheme.AddCellTheme("flowsheet")
	MyTheme.Cell("flowsheet").BorderColor = ABM.COLOR_GREY
	MyTheme.Cell("flowsheet").BorderStyle = ABM.BORDER_NONE' ABM.BORDER_SOLID
	' MyTheme.Cell("flowsheet").BorderColorIntensity = ABM.INTENSITY_LIGHTEN1
	MyTheme.Cell("flowsheet").BorderWidth = 1
	MyTheme.AddCellTheme("charttrend")
	MyTheme.Cell("charttrend").BorderColor = ABM.COLOR_GREY
	MyTheme.Cell("charttrend").BorderStyle = ABM.BORDER_SOLID	' ABM.BORDER_RIDGE
	MyTheme.Cell("charttrend").BorderColorIntensity = ABM.INTENSITY_LIGHTEN2
	MyTheme.Cell("charttrend").BorderWidth = 2
	MyTheme.Cell("charttrend").Align = ABM.CELL_ALIGN_LEFT
	MyTheme.Cell("charttrend").BackColor = ABM.COLOR_GREY
	MyTheme.Cell("charttrend").BackColorIntensity = ABM.INTENSITY_LIGHTEN3
	MyTheme.AddCellTheme("controlmessage")
	MyTheme.Cell("controlmessage").Align = ABM.CELL_ALIGN_LEFT
	MyTheme.Cell("controlmessage").BackColor = ABM.COLOR_GREY
	MyTheme.Cell("controlmessage").BackColorIntensity = ABM.INTENSITY_LIGHTEN5
	MyTheme.Cell("controlmessage").VerticalAlign = True

	' Labels
	MyTheme.AddLabelTheme("alignleft")
	MyTheme.Label("alignleft").Align = ABM.TEXTALIGN_LEFT
	MyTheme.AddLabelTheme("aligncenter")
	MyTheme.Label("aligncenter").Align = ABM.TEXTALIGN_CENTER
	MyTheme.AddLabelTheme("alignright")
	MyTheme.Label("alignright").Align = ABM.TEXTALIGN_RIGHT

	MyTheme.AddLabelTheme("labelred")
	MyTheme.Label("labelred").ForeColor = ABM.COLOR_RED

	MyTheme.AddLabelTheme("labelredc")
	MyTheme.Label("labelredc").ForeColor = ABM.COLOR_RED
	MyTheme.Label("labelredc").Align = ABM.TEXTALIGN_CENTER

	MyTheme.AddLabelTheme("labelgreen")
	MyTheme.Label("labelgreen").ForeColor = ABM.COLOR_GREEN

	MyTheme.AddLabelTheme("labelgreenc")
	MyTheme.Label("labelgreenc").ForeColor = ABM.COLOR_GREEN
	MyTheme.Label("labelgreenc").Align = ABM.TEXTALIGN_CENTER

	MyTheme.AddLabelTheme("labelblue")
	MyTheme.Label("labelblue").ForeColor = ABM.COLOR_BLUE

	MyTheme.AddLabelTheme("labelbluec")
	MyTheme.Label("labelbluec").ForeColor = ABM.COLOR_BLUE
	MyTheme.Label("labelbluec").Align = ABM.TEXTALIGN_CENTER

	MyTheme.AddLabelTheme("bluegrey")
	MyTheme.Label("bluegrey").ForeColor = ABM.COLOR_BLUEGREY
	MyTheme.Label("bluegrey").Align = ABM.TEXTALIGN_LEFT

	MyTheme.AddLabelTheme("bluegreyc")
	MyTheme.Label("bluegreyc").ForeColor = ABM.COLOR_BLUEGREY
	MyTheme.Label("bluegreyc").Align = ABM.TEXTALIGN_CENTER

	MyTheme.AddLabelTheme("bluegreyr")
	MyTheme.Label("bluegreyr").ForeColor = ABM.COLOR_BLUEGREY
	MyTheme.Label("bluegreyr").Align = ABM.TEXTALIGN_RIGHT

	' Buttons
	MyTheme.AddButtonTheme("buttongreen")
	MyTheme.Button("buttongreen").BackColor = ABM.COLOR_GREEN
	MyTheme.Button("buttongreen").BackColorIntensity = ABM.INTENSITY_DARKEN4
	MyTheme.Button("buttongreen").ForeColor = ABM.COLOR_WHITE

	MyTheme.AddButtonTheme("buttonred")
	MyTheme.Button("buttonred").BackColor = ABM.COLOR_RED
	MyTheme.Button("buttonred").BackColorIntensity = ABM.INTENSITY_DARKEN4
	MyTheme.Button("buttonred").ForeColor = ABM.COLOR_WHITE
	
	MyTheme.AddButtonTheme("buttonredrounded")
	MyTheme.Button("buttonredrounded").BackColor = ABM.COLOR_RED
	MyTheme.Button("buttonredrounded").BackColorIntensity = ABM.INTENSITY_DARKEN4
	MyTheme.Button("buttonredrounded").ForeColor = ABM.COLOR_WHITE
	MyTheme.Button("buttonredrounded").WavesCircle = True

	MyTheme.AddButtonTheme("buttongrey")
	MyTheme.Button("buttongrey").BackColor = ABM.COLOR_GREY
	MyTheme.Button("buttongrey").BackColorIntensity = ABM.INTENSITY_DARKEN1
'	MyTheme.Button("buttongrey").ForeColor = ABM.COLOR_WHITE
		
	MyTheme.AddButtonTheme("buttonorange")
	MyTheme.Button("buttonorange").BackColor = ABM.COLOR_ORANGE
	MyTheme.Button("buttonorange").BackColorIntensity = ABM.INTENSITY_DARKEN1
		
	MyTheme.AddButtonTheme("buttonteal")
	MyTheme.Button("buttonteal").BackColor = ABM.COLOR_TEAL
	MyTheme.Button("buttonteal").BackColorIntensity = ABM.INTENSITY_DARKEN1
		
	MyTheme.AddButtonTheme("buttonyellow")
	MyTheme.Button("buttonyellow").BackColor = ABM.COLOR_YELLOW
	MyTheme.Button("buttonyellow").BackColorIntensity = ABM.INTENSITY_DARKEN1
		
	MyTheme.AddButtonTheme("buttoncyan")
	MyTheme.Button("buttoncyan").BackColor = ABM.COLOR_CYAN
	MyTheme.Button("buttoncyan").BackColorIntensity = ABM.INTENSITY_DARKEN1
		
	' Modal sheet
	MyTheme.AddModalSheetTheme("modal")
	MyTheme.ModalSheet("modal").Colorize("dragonfly")
	MyTheme.ModalSheet("modal").ContentBackColorIntensity = ABM.INTENSITY_LIGHTEN1

	MyTheme.AddContainerTheme("modalcontent")
	MyTheme.Container("modalcontent").BackColor = "dragonfly"
	MyTheme.Container("modalcontent").BackColorIntensity = ABM.INTENSITY_NORMAL
	
	MyTheme.AddContainerTheme("modalfooter")
	MyTheme.Container("modalfooter").BackColor = "dragonfly"
	MyTheme.Container("modalfooter").BackColorIntensity = ABM.INTENSITY_DARKEN3

	' Switch
	MyTheme.AddSwitchTheme("loading")
	MyTheme.Switch("loading").LabelColor = ABM.COLOR_BLACK
	MyTheme.Switch("loading").LabelFontSize = ABM.SIZE_H3
	MyTheme.Switch("loading").SwitchOffColor = ABM.COLOR_RED
	'MyTheme.Switch("loading").SwitchOffColorIntensity = ABM.INTENSITY_DARKEN4
	MyTheme.Switch("loading").SwitchOnColor = ABM.COLOR_GREEN
	'MyTheme.Switch("loading").SwitchOnColorIntensity = ABM.INTENSITY_DARKEN4
	MyTheme.Switch("loading").BarOffColor = ABM.COLOR_RED
	MyTheme.Switch("loading").BarOffColorIntensity = ABM.INTENSITY_DARKEN4
	MyTheme.Switch("loading").BarOnColor = ABM.COLOR_GREEN
	MyTheme.Switch("loading").BarOnColorIntensity = ABM.INTENSITY_DARKEN4

	' Slider
	MyTheme.AddSliderTheme("lrc6001")
	MyTheme.Slider("lrc6001").ButtonTextColor = ABM.COLOR_RED
	
	' Toast
	MyTheme.AddToastTheme("toastred")
	MyTheme.Toast("toastred").Rounded = True
	MyTheme.Toast("toastred").ForeColor = ABM.COLOR_WHITE
	MyTheme.Toast("toastred").ActionForeColor = ABM.COLOR_WHITE
	MyTheme.Toast("toastred").BackColor = ABM.COLOR_RED
	MyTheme.Toast("toastred").BackColorIntensity = ABM.INTENSITY_DARKEN1
	
	MyTheme.AddToastTheme("toastorange")
	MyTheme.Toast("toastorange").Rounded = True
	MyTheme.Toast("toastorange").ForeColor = ABM.COLOR_WHITE
	MyTheme.Toast("toastorange").ActionForeColor = ABM.COLOR_WHITE
	MyTheme.Toast("toastorange").BackColor = ABM.COLOR_ORANGE
	MyTheme.Toast("toastorange").BackColorIntensity = ABM.INTENSITY_DARKEN1
	
	MyTheme.AddToastTheme("toastgreen")
	MyTheme.Toast("toastgreen").ForeColor = ABM.COLOR_WHITE
	MyTheme.Toast("toastgreen").BackColor = "dragonflygreen"
	MyTheme.Toast("toastgreen").BackColorIntensity = ABM.INTENSITY_DARKEN2
End Sub

Sub BuildNavigationBar(page As ABMPage, Title As String, logo As String, ActiveTopReturnName As String, ActiveSideReturnName As String, ActiveSideSubReturnName As String) 	'ignore	
	' we have to make an ABMImage from our logo url
	Dim sbtopimg As ABMImage
	sbtopimg.Initialize(page, "sbtopimg", logo, 1)
	sbtopimg.SetFixedSize(236, 49)	

	page.NavigationBar.Initialize(page, "nav1", ABM.SIDEBAR_MANUAL_HIDEMEDIUMSMALL, Title, True, True, 330, 48, sbtopimg, ABM.COLLAPSE_ACCORDION, "nav1theme")		
		
	page.NavigationBar.TopBarDropDownConstrainWidth = False
	page.NavigationBar.ActiveTopReturnName = ActiveTopReturnName
	page.NavigationBar.ActiveSideReturnName = ActiveSideReturnName
	page.NavigationBar.ActiveSideSubReturnName = ActiveSideSubReturnName
	
	' you must add at least ONE dummy item if you want to add items to the topbar	in ConnectNaviagationBar
	page.NavigationBar.AddTopItem("DUMMY", "{NBSP}", "", "", False)
	
	' you must add at least ONE dummy item if you want to add items to the sidebar	
	page.NavigationBar.AddSideBarItem("DUMMY", "{NBSP}", "", "")
		
End Sub

Sub ConnectNavigationBar(page As ABMPage) 'ignore	
	' Clear the dummies we created in BuildNavigationBar
	page.NavigationBar.Clear

	page.NavigationBar.AddSideBarItem("LogViewer", "LogViewer", "mdi-action-view-list", "")
	page.NavigationBar.AddSideBarItem("Settings", "Settings", "mdi-action-settings", "")
	page.NavigationBar.AddSideBarItem("About", "About", "mdi-action-dashboard", "")
	
	'page.NavigationBar.AddTopItemWithSideBar("sidebar", "sidebar", "", "", ABM.VISIBILITY_ALL, sb)
		
	page.NavigationBar.Refresh ' IMPORTANT	
End Sub

public Sub BuildParagraph(page As ABMPage, id As String, Text As String) As ABMLabel 'ignore
	Dim lbl As ABMLabel	
	lbl.Initialize(page, id, Text , ABM.SIZE_PARAGRAPH, False, "")
	Return lbl
End Sub

#Region Footer
' Build a footer 
public Sub BuildFooter(page As ABMPage)
	Dim CellSize As Int = 6
	page.isFixedFooter= False
	page.PaddingBottom = 5
	' Add a new row with 2 cells [AppDescr][Appversion]
	page.Footer.AddRows(1, True, "").AddCellsOS(1,0,0,0,CellSize,CellSize,CellSize, "alignleft").AddCellsOS(1,0,0,0,CellSize,CellSize,CellSize, "alignright")
	' Build the grid
	page.Footer.BuildGrid
	page.Footer.UseTheme("bluegrey")
	' Add a label to Row 1, Cell 1
	Dim labelFooterL As ABMLabel
	labelFooterL.Initialize(page, "labelFooterL", $"${Main.APPDESCRIPTION}"$,ABM.SIZE_SMALL, False, "bluegrey")
	page.Footer.Cell(1,1).AddComponent(labelFooterL)
	' Add a label to Row 1, Cell 2
	Dim labelFooterR As ABMLabel
	labelFooterR.Initialize(page, "labelFooterR", $"${Main.APPVERSION}{BR}${Main.APPAUTHOR}"$,ABM.SIZE_SMALL, False, "bluegreyr")
	page.Footer.Cell(1,2).AddComponent(labelFooterR)
End Sub
#End Region

#Region Helpers
Sub BuildSimpleItem(page As ABMPage, id As String, text As String, size As String) As ABMLabel	'ignore
	Dim lbl As ABMLabel
	If size.Length = 0 Then size = ABM.SIZE_PARAGRAPH
	lbl.Initialize(page, id, text, size, True, "")
	lbl.VerticalAlign = True
	Return lbl
End Sub

Sub Mid(Text As String, Start As Int, Length As Int) As String 'ignore
	Return Text.SubString2(Start-1,Start+Length-1)
End Sub

Sub Mid2(Text As String, Start As Int) As String 'ignore
	Return Text.SubString(Start-1)
End Sub

Sub ReplaceAll(Text As String, Pattern As String, Replacement As String) As String 'ignore
	Dim jo As JavaObject = Regex.Matcher(Pattern, Text)
	Return jo.RunMethod("replaceAll", Array(Replacement))
End Sub
#End Region
